//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  Red

//
//
//
//
//

extern int MacdFastEMA   = 12;
extern int MacdSlowEMA   = 26;
extern int MacdSignalEMA =  9;
extern int MacdPrice     = PRICE_CLOSE;

double macduw[];
double macdus[];
double macddw[];
double macdds[];
double signal[];
double trend[];

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,macduw); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macddw); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macdus); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,macdds); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,signal);
   SetIndexBuffer(5,trend);
   return(0);
}

int deinit() { return(0); }

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   double alpha = 2.0/(1.0+MacdSignalEMA);
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i = limit; i >= 0 ; i--)
   {
      double macd = iMA(NULL,0,MacdFastEMA,0,MODE_EMA,MacdPrice,i)-iMA(NULL,0,MacdSlowEMA,0,MODE_EMA,MacdPrice,i);
             signal[i] = signal[i+1]+alpha*(macd-signal[i+1]);
             macduw[i] = EMPTY_VALUE;
             macdus[i] = EMPTY_VALUE;
             macddw[i] = EMPTY_VALUE;
             macdds[i] = EMPTY_VALUE;
             trend[i]  = trend[i+1];
               if (macd>signal[i] && macd>0) trend[i] =  2;
               if (macd>signal[i] && macd<0) trend[i] =  1;
               if (macd<signal[i] && macd>0) trend[i] = -1;
               if (macd<signal[i] && macd<0) trend[i] = -2;
               if (trend[i]== 2) { macdus[i] = High[i]; macdds[i] = Low[i]; }
               if (trend[i]== 1) { macduw[i] = High[i]; macddw[i] = Low[i]; }
               if (trend[i]==-1) { macddw[i] = High[i]; macduw[i] = Low[i]; }
               if (trend[i]==-2) { macdds[i] = High[i]; macdus[i] = Low[i]; }
   }
   return(0);
}